﻿using System.Linq;

namespace NewsSystem.Contracts
{
    public interface IRepository<T> where T : class
    {
        IQueryable<T> GetAll();

        T Get(int id);

        void Add(T entity);

        void Delete(int id);

        void Delete(T entity);

        void Update(int id, T entity);
    }
}
